#include "StdAfx.h"
#include "FLVariable.h"
#include "FLRule.h"
#include "FLMembershipFunction.h"
#include "FuzzySet.h"
#include "flc.h"

int CFLC::nFLC_Counter = 0;

CFLC::CFLC(void)
: FS(NULL)
, FLV(NULL)
, FLRS(NULL)
{
	++nFLC_Counter;
}

CFLC::~CFLC(void)
{
	if (FLRS != NULL)
	{
		delete [] FLRS;
		FLRS = NULL;
	}

	if (FLV != NULL)
	{
		delete [] FLV;
		FLV = NULL;
	}
	
	if (FS != NULL)
	{
		delete [] FS;
		FS = NULL;
	}
}

int CFLC::InitRuleSet(int nSize)
{
	if (FLRS != NULL) return -1;
	FLRS = new CFLRule[nSize];
	return 0;
}

int CFLC::InitVarSet(int nNumVars)
{
	if (FLV != NULL) return -1;
	FLV = new CFLVariable[nNumVars];
	return 0;
}

int CFLC::InitFuzzyStates(int nNumFStates)
{
	if (FS != NULL) return -1;
	FS = new CFuzzySet[nNumFStates];
	return 0;
}
