#pragma once

/*
This is the top FL Controller object
It basically consists of :
	a set of variables (generally 2 inputs and 1 output)
	a set of fuzzy states, which will be attached to the variables
	and a fuzzy rule set

*/
class CFLC
{
public:
	CFLC(void);
	~CFLC(void);
	static int	nFLC_Counter;
	int m_nNumFS;
	int m_nNumVars;
	int m_nRuleSetSize;
	CFuzzySet* FS;
	CFLVariable* FLV;
	CFLRule* FLRS;
	int InitRuleSet(int nSize);
	int InitVarSet(int nNumVars);
	int InitFuzzyStates(int nNumFStates);
};
