#include "StdAfx.h"
#include "FLMembershipFunction.h"

double ShoulderLeft(double x, double t1, double t2);	// 1, then down, then 0
double ShoulderRight(double x, double t1, double t2);	// 0, then up, then 1
double Triangle(double x, double t1, double t2);

int CFLMembershipFunction::m_nPremiseCounter = 0;

CFLMembershipFunction::CFLMembershipFunction(void)
{
	DOM=0.0;
}

CFLMembershipFunction::~CFLMembershipFunction(void){}

void CFLMembershipFunction::CalcDOM(double x)
{
	switch (m_nType)
	{
		case 0:		//		-\  ShoulderRight
			DOM = ShoulderRight(x,m_dPoint1,m_dPoint2);
			break;
		case 1:		/*		/\	Triangle	*/
			DOM = Triangle(x,m_dPoint1,m_dPoint2);
			break;
		case 2:		//		/-	ShoulderLeft
			DOM = ShoulderLeft(x,m_dPoint1,m_dPoint2);
			break;
		default:
			DOM = 0.0;
	}
}

// Actual MF DOM calculation
double ShoulderLeft(double x, double t1, double t2)
{
	if (t1==t2) return 0.0;
	if (x<=t1)	return 0.0;
	if (x>=t2)	return 1.0;
	return ((x-t1)/(t2-t1));
}

double ShoulderRight(double x, double t1, double t2)
{
	if (t1==t2) return 0.0;
	if (x<=t1)	return 1.0;
	if (x>=t2)	return 0.0;
	return ((x-t2)/(t1-t2));
}

double Triangle(double x, double t1, double t2)
{
	if (x<=t1)	return 0.0;
	if (x>=t2)	return 0.0;
	if (x<=(t1+t2)/2)	return ShoulderLeft(x,t1,(t1+t2)/2);
	else				return ShoulderRight(x,(t1+t2)/2,t2);
}