#include "StdAfx.h"
#include "FLRule.h"

int CFLRule::NumRules = 0;		// static var

CFLRule::CFLRule(int NumPremises)
{
	m_nRuleNumber = NumRules;
	NumRules++;
	m_nNumPremises = NumPremises;
	if (NumPremises > 0)
	{
		m_pnPremise = new int[m_nNumPremises];
		m_pnOperation = new int[m_nNumPremises];
	}
}

CFLRule::CFLRule(void)
{
	m_nRuleNumber = NumRules;
	NumRules++;
	m_nNumPremises = 0;
	m_nConsequent = 0;
	m_pnPremise = NULL;
	m_pnOperation = NULL;
}


CFLRule::~CFLRule(void)
{
	if (m_nNumPremises > 0)
	{
		if (m_pnPremise != NULL) delete [] m_pnPremise;
		if (m_pnOperation != NULL) delete [] m_pnOperation;
	}
}

void CFLRule::Allocate(int NumPremises)
{
	m_nNumPremises = NumPremises;
	if (NumPremises > 0)
	{
		m_pnPremise = new int[m_nNumPremises];
		m_pnOperation = new int[m_nNumPremises];
	}
}

void CFLRule::DeAllocate()
{
	if (m_nNumPremises > 0)
	{
		if (m_pnPremise != NULL) delete [] m_pnPremise;
		if (m_pnOperation != NULL) delete [] m_pnOperation;
	}
}

