#include "StdAfx.h"
#include "Fuzzyset.h"

CFuzzySet::CFuzzySet()		// default constructor
{
	FuzzyState = NULL;
}			

CFuzzySet::CFuzzySet(int NumMFs)	// num states defined in constructor
{
	m_nNumMFs = NumMFs;
	// array of Membership Functions created on the heap
	FuzzyState = new CFLMembershipFunction[NumMFs];
	for (int i=0;i<NumMFs;i++)
	{
		FuzzyState[i].DOM = 0.0;			// Degree of Membership
		FuzzyState[i].m_nType = 0;			// shape
		FuzzyState[i].m_dPoint1 = 0.0;		// shape identifiers
		FuzzyState[i].m_dPoint2 = 0.0;
		//FuzzyState[i].m_dCenter = 0.0;
	}
}

CFuzzySet::CFuzzySet(const CFuzzySet & rhs)	// copy constructor
{
	m_nNumMFs = rhs.m_nNumMFs;
	FuzzyState = new CFLMembershipFunction[m_nNumMFs];
	*FuzzyState = *(rhs.FuzzyState);
}

void CFuzzySet::InitFuzzySet(int NumMFs)
{	// if default constructor was used
	if (FuzzyState != NULL) return;
	m_nNumMFs = NumMFs;
	FuzzyState = new CFLMembershipFunction[NumMFs];
	for (int i=0;i<NumMFs;i++)
	{
		FuzzyState[i].DOM = 0.0;
		FuzzyState[i].m_nType = 0;
		FuzzyState[i].m_dPoint1 = 0.0;
		FuzzyState[i].m_dPoint2 = 0.0;
		//FuzzyState[i].m_dCenter = 0.0;
	}	
}

CFuzzySet::~CFuzzySet(void)			// standard destructor
{
	if (FuzzyState != NULL) delete [] FuzzyState;
}
